=== debian/changelog ===
wmbusmeters (1.13.1-3) experimental; urgency=medium

  * Update build dependencies.

 -- Fredrik Öhrström <oehrstroem@gmail.com>  Sat, 20 May 2023 12:14:35 +0200

wmbusmeters (1.13.1-2) experimental; urgency=medium

  * Update Vcs-Git and Vcs-Browser.
  * Add build missing dependencies.

 -- Fredrik Öhrström <oehrstroem@gmail.com>  Mon, 15 May 2023 16:17:15 +0200

wmbusmeters (1.13.1-1) experimental; urgency=medium

  * First package upload (Closes: #998721).
  * Upload sponsored by Petter Reinholdtsen.

 -- Fredrik Öhrström <oehrstroem@gmail.com>  Mon, 08 May 2023 13:14:15 +0200
