=== debian/control ===
Source: wmbusmeters
Section: comm
Priority: optional
Maintainer: Fredrik Öhrström <oehrstroem@gmail.com>
Build-Depends: debhelper-compat (= 13)
 , librtlsdr-dev
 , jq
 , xxd
 , netcat-openbsd
Standards-Version: 4.6.1.0
Homepage: https://github.com/wmbusmeters/wmbusmeters
Vcs-Browser: https://salsa.debian.org/weetmuts/package-wmbusmeters.git
Vcs-Git: https://salsa.debian.org/weetmuts/package-wmbusmeters.git
Rules-Requires-Root: no

Package: wmbusmeters
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
 , adduser
Suggests: rtl-wmbus
Description: read wireless and wired M-Bus (EN13757 OMS) telegrams from utility meters
 Receives and decodes C1, T1 or S1 telegrams (using
 the wireless or wired mbus protocol) to acquire utility meter
 readings. The readings can then be published using MQTT,
 curled to a REST API, inserted into a database or stored in a log file.
