=== debian/changelog ===
wmbusmeters (1.20.0-1) unstable; urgency=medium

  * [c2dbdb8] New upstream version 1.20.0.
  * [f770fe4] Add libxslt1-dev build dependency.
  * [3b69199] Update copyright file and licenses.
  * [02f0ef9] Remove explicit gzip compression override.
  * [052a143] Fix paths in systemd. (Closes: #1109566)
  * [98b3af9] Add support for DME Type 173 variant.
  * [7e39685] Add basic salsa-ci configuration.
  * [89d3279] Update maintainer and add uploaders.
  * [9fec38b] Update Standards-Version and reformat control. (Closes: #1036784)
  * [68598d4] Respect CPPFLAGS during build.
  * [afdd948] Add comprehensive autopkgtests.

 -- Anton Gladky <gladk@debian.org>  Thu, 05 Feb 2026 19:57:20 +0100
