=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_CPPFLAGS_MAINT_APPEND = -D_FORTIFY_SOURCE=2

CHANGELOG_VERSION := $(shell dpkg-parsechangelog -S Version)

%:
	dh $@

override_dh_auto_build:
	$(MAKE) COMMIT_HASH= TAG=$(CHANGELOG_VERSION) BRANCH= CHANGES=

override_dh_auto_test:
	$(MAKE) test COMMIT_HASH= TAG=$(CHANGELOG_VERSION) BRANCH= CHANGES=
