=== debian/tests/control ===
Tests: basic-functionality
Depends: @, jq

Tests: version-check
Depends: @

Tests: help-output
Depends: @

Tests: robustness
Depends: @
